﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using SQLiteWrapperUWP_PCL_BasicExample.Core;
using SQLite.Net.Platform.WinRT;
using SQLiteWrapperUWP_PCL_BasicExample.UWP.Helpers;
using SQLiteWrapperUWP_PCL_BasicExample.Core.Services;
using Windows.Storage;
using BuiltToRoam.Data.SQLite.Repository;
using SQLiteWrapperUWP_PCL_BasicExample.Core.Models.Database;
using SQLite.Net;
using System.Collections.ObjectModel;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace SQLiteWrapperUWP_PCL_BasicExample.UWP
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        private SQLiteConnection dbConnection;
        private PersonService personService;

        public string DatabaseFilePath { get; set; }

        public ObservableCollection<PersonEntity> Persons { get; set; }

        public MainPage()
        {
            this.InitializeComponent();
        }

        protected async override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);

            // Create a database service
            var databaseService = new DatabaseService(new SqlPlatformProvider());

            // Creates a db file
            var dbFile = await ApplicationData.Current.LocalFolder.CreateFileAsync("test.db", CreationCollisionOption.OpenIfExists);
            DatabaseFilePath = dbFile.Path;
            // Creates and opens db connection
            dbConnection = databaseService.CreateAndOpenDb(dbFile.Path);
            // Creates a person service
            personService = new PersonService(dbConnection);

            Persons = new ObservableCollection<PersonEntity>(personService.RetrieveAll());
        }

        private void AddNick(object sender, RoutedEventArgs e)
        {
            var newPerson = new PersonEntity()
            {
                Name = "Nick",
                Surname = "Cage"
            };
            personService.Insert(newPerson);
            Persons.Add(newPerson);
            //Persons = new ObservableCollection<PersonEntity>(Persons);
            newPerson.NotifyPropertyChanged();
        }
    }
}
